
/* Hive Spin Compiler spin interpreter opcodes */
/* This code is public domain */

#define OP_BYTEFILL   0x18
#define OP_WORDFILL   0x19
#define OP_LONGFILL   0x1a
#define OP_WAITPEQ    0x1b
#define OP_BYTEMOVE   0x1c
#define OP_WORDMOVE   0x1d
#define OP_LONGMOVE   0x1e
#define OP_WAITPNE    0x1f
#define OP_CLKSET     0x20
#define OP_COGSTOP    0x21
#define OP_LOCKRET    0x22
#define OP_WAITCNT    0x23

#define OP_WAITVID    0x27

#define OP_ABORT      0x30
#define OP_ABOVAL     0x31
#define OP_RETURN     0x32
#define OP_RETVAL     0x33

#define OP_ROR        0xe0
#define OP_ROL        0xe1
#define OP_SHR        0xe2
#define OP_SHL        0xe3
#define OP_MIN        0xe4
#define OP_MAX        0xe5
#define OP_BITNOT     0xe7
#define OP_BITAND     0xe8
#define OP_ABS        0xe9
#define OP_BITOR      0xea
#define OP_BITXOR     0xeb
#define OP_PLUS       0xec
#define OP_MINUS      0xed
#define OP_SAR        0xee
#define OP_REV        0xef
#define OP_AND        0xf0
#define OP_ENCODE     0xf1
#define OP_OR         0xf2
#define OP_DECODE     0xf3
#define OP_MUL        0xf4
#define OP_MULH       0xf5
#define OP_DIV        0xf6
#define OP_MOD        0xf7
#define OP_SQRT       0xf8
#define OP_LT         0xf9
#define OP_GT         0xfa
#define OP_NE         0xfb
#define OP_EQ         0xfc
#define OP_LTEQ       0xfd
#define OP_GTEQ       0xfe
#define OP_NOT        0xff

#define OP_LIST      0x100

